# Pew!
A multi-threaded raytracer following https://raytracing.github.io/

## Dependencies
```
sdl2
sdl2_ttf
```

## Build & Run
```sh
mkdir build && cd build
cmake -DCMAKE_BUILD_TYPE=Release ..
cmake --build . --config Release
./src/pew/pew
```

## Controls
```
<SPACE>     Pause rendering
u           Show final render
i           Show materials as colors
s           Save render in current state at ./shot.png
```

## Screenshots

##### A complete scene
![Rendered scene](./assets/scene.png)

##### Rendered out image
![another shot](./assets/shot.png)

##### Materials as colors
![Materials as colors](./assets/materials.png)

##### Screenshot of a scene being rendered
![Rendering a scene](./assets/rendering.png)

## Livedemo in WASM (wip)
https://evysgarden.org/raytrace/main.html
